PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Attributes | List of all members
PSyncPointAck Class Reference

This class defines a thread synchronisation object. More...

`#include <syncthrd.h>`

Inheritance diagram for PSyncPointAck:
[legend]
Collaboration diagram for PSyncPointAck:
[legend]

## Public Member Functions
virtual void | Signal ()
| If there are waiting (blocked) threads then unblock the first one that was blocked. More...
void | Signal (const PTimeInterval &waitTime)
void | Acknowledge ()
| This indicates that the thread that was blocked in a Wait() on this synchronisation object has completed the operation the signal was intended to initiate. More...
Public Member Functions inherited from PSyncPoint
| PSyncPoint ()
| Create a new sync point. More...
| PSyncPoint (const PSyncPoint &)
virtual void | Wait ()
| Block until the synchronisation object is available. More...
virtual PBoolean | Wait (const PTimeInterval &timeout)
| Block, for a time, until the synchronisation object is available. More...
Public Member Functions inherited from PSync
| PSync ()
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes
PSyncPoint | ack

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Friends inherited from PObject

## Detailed Description

This class defines a thread synchronisation object.

This may be used to send signals to a thread and await an acknowldegement that the signal was processed. This can be be used to initiate an action in another thread and wait for the action to be completed.

        ... thread one
        while (condition) {
          sync.Wait();
          do_something();
          sync.Acknowledge();
        }

        ... thread 2
        do_something_else();
        sync.Signal();    // At this point thread 1 wake up and does something.
        do_yet_more();    // However, this does not get done until Acknowledge()
    is called in the other thread.

## Member Function Documentation

void PSyncPointAck::Acknowledge | ( |  | ) |

This indicates that the thread that was blocked in a Wait() on this synchronisation object has completed the operation the signal was intended to initiate.

This unblocks the thread that had called the Signal() function to initiate the action.

virtual void PSyncPointAck::Signal | ( |  | ) |
| virtual

If there are waiting (blocked) threads then unblock the first one that was blocked.

If no waiting threads and the count is less than the maximum then increment the semaphore.

Unlike the PSyncPoint::Signal() this function will block until the target thread that was blocked by the Wait() function has resumed execution and called the Acknowledge() function.

The `waitTime` parameter is used as a maximum amount of time to wait for the achnowledgement to be returned from the other thread.

Reimplemented from PSyncPoint.

void PSyncPointAck::Signal | ( | const PTimeInterval & | waitTime | ) |

## Member Data Documentation

PSyncPoint PSyncPointAck::ack
| protected

The documentation for this class was generated from the following file:

- syncthrd.h